Public Class CustomGameDialog

    Private m_width As Integer
    Private m_height As Integer
    Private m_mines As Integer

    Public ReadOnly Property FieldWidth() As Integer
        Get
            Return Me.m_width
        End Get
    End Property

    Public ReadOnly Property FieldHeight() As Integer
        Get
            Return Me.m_height
        End Get
    End Property

    Public ReadOnly Property Mines() As Integer
        Get
            Return Me.m_mines
        End Get
    End Property

    Public Sub New(ByVal fieldWidth As Integer, ByVal fieldHeight As Integer, ByVal mines As Integer)
        ' This call is required by the Windows Form Designer.
        InitializeComponent()

        Me.m_width = fieldWidth
        Me.m_height = fieldHeight
        Me.m_mines = mines
    End Sub

    Private Sub CustomGameDialog_Load(ByVal sender As Object, ByVal e As EventArgs) Handles MyBase.Load
        Me.widthTextbox.Text = Me.m_width.ToString()
        Me.heightTextbox.Text = Me.m_height.ToString()
        Me.minesTextbox.Text = Me.m_mines.ToString()
    End Sub

    Private Sub okButton_Click(ByVal sender As Object, ByVal e As EventArgs) Handles okButton.Click
        If Not Me.ValidateInput() Then
            Microsoft.VisualBasic.MsgBox("Values are invalid.", Microsoft.VisualBasic.MsgBoxStyle.Exclamation, "Error")
        Else
            Me.DialogResult = Windows.Forms.DialogResult.OK
            Me.Close()
        End If
    End Sub

    Private Function ValidateInput() As Boolean
        If ( _
            Integer.TryParse(Me.widthTextbox.Text, Me.m_width) AndAlso _
            Integer.TryParse(Me.heightTextbox.Text, Me.m_height) AndAlso _
            Integer.TryParse(Me.minesTextbox.Text, Me.m_mines) _
        ) Then
            If Me.m_width < 5 OrElse Me.m_width > 30 Then
                Me.widthTextbox.SelectAll()
                Me.widthTextbox.Focus()
                Return False
            ElseIf Me.m_height < 5 OrElse Me.m_height > 30 Then
                Me.heightTextbox.SelectAll()
                Me.heightTextbox.Focus()
                Return False
            ElseIf Me.m_mines < 5 OrElse Me.m_mines > Me.m_width * Me.m_height \ 4 Then
                Me.minesTextbox.SelectAll()
                Me.minesTextbox.Focus()
                Return False
            End If

            Return True
        End If
    End Function

End Class
